package com.xr.base;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5 {
	/**
	 * 对信息进行MD5加密
	 * 
	 * @param message
	 *            信息
	 * @return
	 * @throws NoSuchAlgorithmException
	 */
	public static String MD5Encrypt(String message) {
		String result = null;
		if (null != message || "".equals(message)) {
			result = "";
		}
		try {
			result = byteToHex(encryptMD5(message.getBytes("utf-8")));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		}

		return result;

	}
	
	/**
	 * MD5加密
	 * 
	 * @param data
	 * @return
	 * @throws NoSuchAlgorithmException
	 */
	private static byte[] encryptMD5(byte[] data) throws NoSuchAlgorithmException {
		MessageDigest md5 = MessageDigest.getInstance("MD5");
		md5.update(data);
		return md5.digest();
	}
	
	/**
	 * 字节数组转换为16进制字符串
	 * 
	 * @param inbuf
	 *            字节数组
	 * @return
	 */
	private static String byteToHex(byte[] inbuf) {
		StringBuffer strBuf = new StringBuffer();
		for (int i = 0; i < inbuf.length; i++) {
			String byteStr = Integer.toHexString(inbuf[i] & 0x00ff);
			if (byteStr.length() != 2) {
				strBuf.append('0').append(byteStr);
			} else {
				strBuf.append(byteStr);
			}
		}
		return new String(strBuf);
	}
}
